VERSION 5.00
Object = "{32ACDEC0-C52B-11D0-9227-444553540000}#1.0#0"; "SPRITEX.OCX"
Begin VB.Form Demo2Form 
   Caption         =   "SpriteX Demo 2"
   ClientHeight    =   4335
   ClientLeft      =   1080
   ClientTop       =   1515
   ClientWidth     =   5265
   Icon            =   "demo2.frx":0000
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   289
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   351
   Begin SPRITEXLib.SpriteX Sprite1 
      Height          =   3495
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   3855
      _Version        =   65536
      _ExtentX        =   6800
      _ExtentY        =   6165
      _StockProps     =   0
   End
End
Attribute VB_Name = "Demo2Form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Croc 96x61
'Rhino 80x91
'Bee 50x30
'Bat 87x67
'Snake 95x44
'Spider 33x26

Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

Private Type Anim
    x As Integer
    y As Integer
    Index As Integer
    MoveX As Integer
    MoveY As Integer
    Action As Integer
    Frame As Integer
    Count As Integer
End Type

Dim Rhino As Anim
Dim Snake As Anim
Dim Croc As Anim
Dim Spider As Anim
Dim Bee As Anim

Dim World(7, 10) As Integer

Const KEY_LEFT = 37
Const KEY_UP = 38
Const KEY_RIGHT = 39
Const KEY_DOWN = 40

Const STAGE_LEFT = 10
Const STAGE_RIGHT = 550
Const STAGE_TOP = 10
Const STAGE_BOTTOM = 363

Const RHINO_LEFT = 0
Const RHINO_RIGHT = 8
Const RHINO_STOP = 19
Const RHINO_FOOT = 20
Const RHINO_HURRY = 27
Const RHINO_JUMP = 29
Const RHINO_CLIMB = 32
Const RHINO_FALL = 31
Const RHINO_CROUCH = 28
Const RHINO_LAND = 25

Const CHECK_LEFT = 55
Const CHECK_MIDDLE = 40
Const CHECK_RIGHT = 25
Const CHECK_TOP = 22
Const CHECK_BOTTOM = 84

Const SNAKE_LEFT = 6
Const SNAKE_RIGHT = 0
Const SNAKE_TURN_LEFT = 3
Const SNAKE_TURN_RIGHT = 5
Private Function CheckKey() As Integer
    ' Returns one of the arrow keys if pressed or zero

    If GetAsyncKeyState(KEY_LEFT) Then
        CheckKey = KEY_LEFT
    ElseIf GetAsyncKeyState(KEY_RIGHT) Then
        CheckKey = KEY_RIGHT
    ElseIf GetAsyncKeyState(KEY_UP) Then
        CheckKey = KEY_UP
    ElseIf GetAsyncKeyState(KEY_DOWN) Then
        CheckKey = KEY_DOWN
    Else
        CheckKey = 0
    End If

End Function




Function CheckWorld() As Integer
    Dim intCol As Integer, intRow As Integer
    Dim intYOffSet As Integer, intXOffSet As Integer

    If Rhino.MoveX Then
        If Rhino.MoveX < 0 Then
            intXOffSet = CHECK_LEFT
        Else
            intXOffSet = CHECK_RIGHT
        End If
    Else
        intXOffSet = CHECK_MIDDLE
    End If

    If Rhino.MoveY <= 0 Or Rhino.Action = RHINO_CLIMB Then
        intYOffSet = CHECK_BOTTOM
    Else
        intYOffSet = CHECK_TOP
    End If

    intCol = Int((Rhino.x + intXOffSet) / 64)
    intRow = Int((Rhino.y + intYOffSet) / 64)
    If intCol < 0 Then intCol = 0
    If intRow < 0 Then intRow = 0

    CheckWorld = World(intRow, intCol)

    #If RhinoDebug Then
        ShowData CheckWorld, intRow, intCol
    #End If
End Function

Sub LoadWorld()
    Dim intRow As Integer, intCol As Integer
    Dim intFileNum As Integer, intRows As Integer, intCols As Integer
    Dim strTemp As String, lngNewPos As Long, lngOldPos As Long

    intFileNum = FreeFile

    Open App.Path + "\world.dat" For Input As intFileNum

    Line Input #intFileNum, strTemp
    intRows = Val(strTemp)
    Line Input #intFileNum, strTemp
    intCols = strTemp

    For intRow = 0 To intRows - 1
        Line Input #intFileNum, strTemp
        lngOldPos = 1
        lngNewPos = 1
        For intCol = 0 To intCols - 1
            lngNewPos = InStr(lngNewPos, strTemp, " ")
            If lngNewPos = 0 Then lngNewPos = Len(strTemp) + 1
            World(intRow, intCol) = Val(Mid(strTemp, lngOldPos, lngNewPos - lngOldPos))
            lngNewPos = lngNewPos + 1
            lngOldPos = lngNewPos
        Next
    Next

    Close intFileNum
End Sub


Sub MoveAnimals()
    If Spider.Count Then
        Spider.Count = Spider.Count - 1
        Spider.y = -40
    Else
        Spider.Frame = (Spider.Frame + 1) Mod 5
        Spider.x = Spider.x + Spider.MoveX
        If Spider.y < 230 Then Spider.y = Spider.y + 10
        If Spider.x > 400 Then Spider.MoveX = -4
        If Spider.x < 257 Then Spider.MoveX = 4
    End If

    Select Case Snake.Action
    Case SNAKE_LEFT
        If Snake.x < 385 Then
            Snake.Action = SNAKE_TURN_RIGHT
            Snake.MoveX = 0
        Else
            Snake.Frame = (Snake.Frame + 1) Mod 3 + SNAKE_LEFT
            Snake.x = Snake.x + Snake.MoveX
        End If
    Case SNAKE_TURN_LEFT
        Snake.Frame = Snake.Frame + 1
        If Snake.Frame = 5 Then
            Snake.Action = SNAKE_LEFT
            Snake.MoveX = -4
        End If
    Case SNAKE_RIGHT
        If Snake.x > 510 Then
            Snake.Action = SNAKE_TURN_LEFT
            Snake.MoveX = 0
        Else
            Snake.Frame = (Snake.Frame + 1) Mod 3 + SNAKE_RIGHT
            Snake.x = Snake.x + Snake.MoveX
        End If
    Case SNAKE_TURN_RIGHT
        Snake.Frame = Snake.Frame - 1
        If Snake.Frame = 3 Then
            Snake.Action = SNAKE_RIGHT
            Snake.MoveX = 4
        End If
    End Select

    Bee.Frame = (Bee.Frame + 1) Mod 3
    Bee.x = Bee.x - Int(Rnd() * 10)
    Bee.y = Bee.y + Int(Rnd() * 10 - 5)
    If Bee.x < 0 Then
        Bee.x = 640
        Bee.y = Int(Rnd() * 400 + 80)
    End If

    Sprite1.MoveSprite Snake.Index, Snake.x, Snake.y, Snake.Frame
    Sprite1.MoveSprite Bee.Index, Bee.x, Bee.y, Bee.Frame
    Sprite1.MoveSprite Croc.Index, Croc.x, Croc.y, Croc.Frame
    Sprite1.MoveSprite Spider.Index, Spider.x, Spider.y, Spider.Frame
End Sub

Sub RhinoFallOrLand()
    Dim intCurrentCell As Integer

    Select Case Rhino.Action
    Case RHINO_FALL
        intCurrentCell = CheckWorld
        If intCurrentCell = 4 Then intCurrentCell = 0
        'Debug.Print intCurrentCell
        If Rhino.y > STAGE_BOTTOM Or intCurrentCell Then
            Rhino.Action = RHINO_LAND
            Rhino.Frame = RHINO_LAND
            Rhino.MoveY = 0
            Rhino.MoveX = 0
            Rhino.y = Rhino.y - ((Rhino.y + CHECK_TOP) Mod 64)
        Else
            Rhino.MoveY = Rhino.MoveY + 4
            Rhino.y = Rhino.y + Rhino.MoveY
            Rhino.x = Rhino.x + Rhino.MoveX
        End If
    Case RHINO_LAND
        If Rhino.Frame = RHINO_LAND Then
            Rhino.Frame = 26
        Else
            Rhino.Frame = RHINO_STOP
            Rhino.Action = RHINO_STOP
            Rhino.Count = 0
        End If
    End Select
End Sub

Sub RhinoKeyDown()
    Dim intCurrentCell As Integer

    intCurrentCell = CheckWorld

    Select Case Rhino.Action
    Case RHINO_CLIMB
        If intCurrentCell > 1 And intCurrentCell < 5 Then
            Rhino.MoveY = Rhino.MoveY + 1
            If Rhino.MoveY > 10 Then Rhino.MoveY = 10
        Else
            'Bottom of ladder
            Do
                Rhino.y = Rhino.y - 1
                intCurrentCell = CheckWorld
            Loop Until (intCurrentCell = 3)
            Rhino.MoveY = 0
        End If
        Rhino.y = Rhino.y + Rhino.MoveY
        Rhino.Frame = (Rhino.Frame - 1) Mod 8 + Rhino.Action
    Case Else
        Rhino.MoveY = 1
        Rhino.MoveX = 0
        Rhino.Action = RHINO_CLIMB
        Rhino.Frame = RHINO_CLIMB
    End Select

    If Rhino.y > STAGE_BOTTOM Then Rhino.y = STAGE_BOTTOM

End Sub
Sub RhinoKeyLeft()
    Dim intCurrentCell As Integer

    intCurrentCell = CheckWorld

    Select Case Rhino.Action
    Case RHINO_JUMP
        If Rhino.Frame < RHINO_JUMP + 2 Then
            Rhino.Frame = Rhino.Frame + 1
        End If
        If Rhino.MoveX > 0 Then Rhino.MoveX = 0
        Rhino.MoveX = Rhino.MoveX - 1
        Rhino.x = Rhino.x + Rhino.MoveX
        Rhino.y = Rhino.y + Rhino.MoveY
        Rhino.MoveY = Rhino.MoveY + 4
        If Rhino.MoveY > 0 Then Rhino.Action = RHINO_FALL
    Case RHINO_RIGHT
        Rhino.Action = RHINO_LEFT
        Rhino.MoveX = 0
        Rhino.MoveY = 0
    Case RHINO_LEFT
        If intCurrentCell And ((Rhino.y + CHECK_TOP) Mod 64) < 4 Then
            'Walk OK
            Rhino.MoveX = Rhino.MoveX - 1
            If Rhino.MoveX < -10 Then Rhino.MoveX = -10
            Rhino.x = Rhino.x + Rhino.MoveX
            If Rhino.x < STAGE_LEFT Then Rhino.x = STAGE_LEFT
            Rhino.Frame = ((Rhino.Frame + 1) Mod 8) + RHINO_LEFT
        Else
            Rhino.Action = RHINO_FALL
        End If
    Case RHINO_STOP
        Rhino.Action = RHINO_LEFT
    End Select
End Sub

Sub RhinoKeyNone()
    Dim intCurrentCell As Integer

    intCurrentCell = CheckWorld

    If (intCurrentCell = 0 Or intCurrentCell = 4) And Rhino.Action <> RHINO_CLIMB Then
        Rhino.Action = RHINO_FALL
        Exit Sub
    End If

    Select Case Rhino.Action
    Case RHINO_JUMP
        If Rhino.Frame < RHINO_JUMP + 2 Then
            Rhino.Frame = Rhino.Frame + 1
        End If
        Rhino.x = Rhino.x + Rhino.MoveX
        Rhino.y = Rhino.y + Rhino.MoveY
        Rhino.MoveY = Rhino.MoveY + 4
        If Rhino.MoveY > 0 Then Rhino.Action = RHINO_FALL
    Case RHINO_CLIMB
        Rhino.y = Rhino.y - 1
        intCurrentCell = CheckWorld
        Rhino.y = Rhino.y + 1
        Rhino.MoveX = 0
        Rhino.MoveY = 0
        If ((Rhino.y + CHECK_TOP) Mod 64) < 4 And intCurrentCell <> 4 Then
            Rhino.Action = RHINO_STOP
            Rhino.Frame = RHINO_STOP
            Rhino.Count = 0
        End If
    Case RHINO_FALL
        'ignore
    Case RHINO_STOP
        Rhino.MoveX = 0
        Rhino.MoveY = 0
        Rhino.Count = Rhino.Count + 1
        If Rhino.Count = 100 Then
            Rhino.Frame = 27
        ElseIf Rhino.Count = 105 Then
            Rhino.Frame = 28
        ElseIf Rhino.Count = 150 Then
            Rhino.Frame = 27
        ElseIf Rhino.Count = 155 Then
            Rhino.Frame = RHINO_STOP
            Rhino.Count = 0
        ElseIf Int(Rhino.Count / 5) = Rhino.Count / 5 And Rhino.Count < 100 Then
            Rhino.Frame = RHINO_STOP - (Rhino.Frame = RHINO_STOP)
        End If
    Case Else
        Rhino.Count = 0
        Rhino.Frame = RHINO_STOP
        Rhino.Action = RHINO_STOP
    End Select
End Sub

Sub RhinoKeyRight()
    Dim intCurrentCell As Integer

    intCurrentCell = CheckWorld

    Select Case Rhino.Action
    Case RHINO_JUMP
        If Rhino.Frame < RHINO_JUMP + 2 Then
            Rhino.Frame = Rhino.Frame + 1
        End If
        If Rhino.MoveX < 0 Then Rhino.MoveX = 0
        Rhino.MoveX = Rhino.MoveX + 1
        Rhino.x = Rhino.x + Rhino.MoveX
        Rhino.y = Rhino.y + Rhino.MoveY
        Rhino.MoveY = Rhino.MoveY + 4
        If Rhino.MoveY > 0 Then Rhino.Action = RHINO_FALL
    Case RHINO_LEFT
        Rhino.Action = RHINO_RIGHT
        Rhino.MoveX = 0
        Rhino.MoveY = 0
    Case RHINO_RIGHT
        If intCurrentCell And ((Rhino.y + CHECK_TOP) Mod 64) < 4 Then
            'Walk OK
            Rhino.MoveX = Rhino.MoveX + 1
            If Rhino.MoveX > 10 Then Rhino.MoveX = 10
            Rhino.x = Rhino.x + Rhino.MoveX
            If Rhino.x > STAGE_RIGHT Then Rhino.x = STAGE_RIGHT
            Rhino.Frame = ((Rhino.Frame + 1) Mod 8) + RHINO_RIGHT
        Else
            Rhino.Action = RHINO_FALL
        End If
    Case RHINO_STOP
        Rhino.Action = RHINO_RIGHT
    End Select
End Sub

Sub RhinoKeyUp()
    Dim intCurrentCell As Integer

    If Rhino.Action = RHINO_JUMP Then
        If Rhino.Frame < RHINO_JUMP + 2 Then
            Rhino.Frame = Rhino.Frame + 1
        End If
        Rhino.x = Rhino.x + Rhino.MoveX
        Rhino.y = Rhino.y + Rhino.MoveY
        Rhino.MoveY = Rhino.MoveY + 4
        If Rhino.MoveY > 0 Then Rhino.Action = RHINO_FALL
        Exit Sub
    End If

    intCurrentCell = CheckWorld

    If intCurrentCell = 3 Or intCurrentCell = 4 Then
        Select Case Rhino.Action
        Case RHINO_CLIMB
            Rhino.MoveY = Rhino.MoveY - 1
            If Rhino.MoveY < -10 Then Rhino.MoveY = -10
            Rhino.y = Rhino.y + Rhino.MoveY
            Rhino.Frame = (Rhino.Frame + 1) Mod 8 + Rhino.Action
        Case Else
            Rhino.MoveY = -1
            Rhino.MoveX = 0
            Rhino.Action = RHINO_CLIMB
            Rhino.Frame = RHINO_CLIMB
        End Select
    Else
        Select Case Rhino.Action
        Case RHINO_CLIMB
            Do
                Rhino.y = Rhino.y + 1
                intCurrentCell = CheckWorld
            Loop Until intCurrentCell <> 2
            Rhino.y = Rhino.y - 1
            Rhino.MoveY = 0
            Rhino.Action = RHINO_STOP
            Rhino.Frame = RHINO_STOP
            Rhino.Count = 0
        Case Else
            If intCurrentCell Then
                Rhino.Action = RHINO_JUMP
                Rhino.Frame = RHINO_JUMP
                Rhino.MoveY = -20
            End If
        End Select
    End If
End Sub
Sub ShowData(iWorld As Integer, iRow As Integer, iCol As Integer)
    Caption = "Rhino (" + Str(Rhino.x) + "," _
                        + Str(Rhino.y) + ")  World: (" + Str(iRow) + "," _
                        + Str(iCol) + ") = " + Str(iWorld) + "  Current Action:" _
                        + Str(Rhino.Action) + " Move data (" + Str(Rhino.MoveX) + _
                        "," + Str(Rhino.MoveY) + ")"
End Sub

Sub ShowWorld()
    Dim intRow As Integer, intCol As Integer

    For intRow = 0 To 6
        Debug.Print
        For intCol = 0 To 9
            Debug.Print World(intRow, intCol);
        Next
    Next
End Sub


Private Sub Form_Load()
    Width = 640 * Screen.TwipsPerPixelX
    Height = 480 * Screen.TwipsPerPixelY
    Left = (Screen.Width - Width) / 2
    Top = (Screen.Height - Height) / 2
    Sprite1.AutoSize = True
    Sprite1.Left = 0
    Sprite1.Top = 0
    Sprite1.LoadBackground App.Path + "\bg.gif", False

    Spider.Index = Sprite1.CreateSprite(App.Path + "\spider.gif", 33, 26)
    Snake.Index = Sprite1.CreateSprite(App.Path + "\snake.gif", 95, 44)
    Croc.Index = Sprite1.CreateSprite(App.Path + "\croc.gif", 96, 61)
    Rhino.Index = Sprite1.CreateSprite(App.Path + "\rhino.gif", 80, 91)
    Bee.Index = Sprite1.CreateSprite(App.Path + "\bee.gif", 50, 30)

    Rhino.x = 55
    Rhino.y = 362
    Rhino.Action = RHINO_STOP
    Rhino.Frame = RHINO_STOP
    Spider.x = 256
    Spider.y = 230
    Bee.x = 640
    Bee.y = 128
    Croc.x = 384
    Croc.y = 398
    Snake.x = 384
    Snake.y = 86
    Snake.MoveX = 4
    LoadWorld
    Sprite1.Fps = 20
    Sprite1.PlayMusicFile App.Path + "\music.mid"
End Sub









Private Sub Sprite1_Timer()
    Dim intKey As Integer

    intKey = CheckKey

    Select Case intKey
    Case KEY_LEFT
        RhinoKeyLeft
    Case KEY_RIGHT
        RhinoKeyRight
    Case KEY_UP
        RhinoKeyUp
    Case KEY_DOWN
        RhinoKeyDown
    Case Else
        RhinoKeyNone
    End Select

    If Rhino.Action = RHINO_FALL Or Rhino.Action = RHINO_LAND Then
        RhinoFallOrLand
    End If

    MoveAnimals
    If Rhino.x > STAGE_RIGHT Then Rhino.x = STAGE_RIGHT
    If Rhino.x < STAGE_LEFT Then Rhino.x = STAGE_LEFT
    Sprite1.MoveSprite Rhino.Index, Rhino.x, Rhino.y, Rhino.Frame
    If Spider.Count = 0 And Sprite1.CollisionCheck(Rhino.Index, Spider.Index, True) Then
        If Rhino.MoveY > 0 Then
            Sprite1.PlaySoundFile App.Path + "\sound3.wav"
            Spider.Count = 100
        Else
            Sprite1.PlaySoundFile App.Path + "\sound2.wav"
        End If
    End If
    Sprite1.UpdateStage
End Sub

